<?php

namespace Drupal\big_datatable;

use Drupal\Core\Config\Entity\ConfigEntityListBuilder;
use Drupal\Core\Entity\EntityInterface;
use Drupal\Core\Link;
use Drupal\Core\Url;

/**
 * Provides a listing of big tables.
 */
class BigTableListBuilder extends ConfigEntityListBuilder {

  /**
   * {@inheritdoc}
   */
  public function buildHeader() {
    $header['label'] = $this->t('Name');
    $header['title'] = $this->t('Title');
    $header['id'] = $this->t('Machine name');

    return $header + parent::buildHeader();
  }

  /**
   * {@inheritdoc}
   */
  public function buildRow(EntityInterface $entity) {
    $url = Url::fromRoute('entity.big_datatable.view', ['big_datatable' => $entity->id()]);
    $row['label']['data']['#markup'] = Link::fromTextAndUrl($entity->label(), $url)->toString();
    $row['title']['data']['#markup'] = Link::fromTextAndUrl($entity->getTitle(), $url)->toString();
    $row['id'] = $entity->id();
    return $row + parent::buildRow($entity);
  }

  /**
   * {@inheritdoc}
   */
  public function getFormId() {
    return 'big_table_entity_list_form';
  }

}
